#!/usr/bin/perl -w
# 
# sb::Plugin::TabulatePlugins - Plugin Module for Serene Bach
# - Written by Gin-Lime / published on 2006-04-07
# -- `Serene Bach' is written by T.Otani
# --   Copyright (C) 2005- SimpleBoxes/SerendipityNZ.

package sb::Plugin::TabulatePlugins;
# ==================================================
# // initialization for plugin
# ==================================================
use sb::Plugin ();
sb::Plugin->register_plugin(
	'lang' => {
		'ja' => 'euc',
		'en' => 'ascii',
	},
	'text' => {
		'type'    => 'admin, cms',
		'name'    => 'Tabulate Plugins',
		'text'    => 'Lists up activated plug-ins',
		'author'  => 'Gin-Lime',
		'detail'  => 'http://www.emeraldshell.com/sb/',
		'version' => '0.01',
		'publish' => 'yes',	# ץ饰ꥹȤΤγĥʸ/
	},
	'file' => 'tabulateplugins.txt',
	'data' => 1,
);
# cmsѥץ饰ȤϿ
sb::Plugin->register_content_module(
	'type'     => 'main',
	'callback' => \&sb::Content::TabulatePlugins::_tabulateplugins,
	'field'    => 'plugins',
);
# adminѥץ饰ȤϿ
sb::Plugin->register_admin_module(
	'mode'   => 'tabulateplugins',
	'level'  => 2,
	'module' => 'sb::Admin::TabulatePlugins',
);
package sb::Content::TabulatePlugins;
use sb::Config ();
# ==================================================
# // declaration for class member
# ==================================================
my %mListScripts = (
	'plugin_list'   => 'plugins.js',
	'plugin_author' => 'plugins_auth.js',
);
# ==================================================
# // declaration for constant value
# ==================================================
sub LINK_FORMAT (){ '<a href="%s" target="_blank"%s>%s</a>' };
sub SPAN_FORMAT (){ '<span%s>%s</span>' };
# ==================================================
# // functions for content
# ==================================================
use sb::Plugin ();
use sb::Build ();
use sb::Language ();
use sb::Admin::Config ();
sub _tabulateplugins {
	my $cms = shift;
	my %var = @_;
	if ($var{'mode'} ne 'page' or $var{'page'} !=0){	# ȥåץڡʳ
		&_script_tag_pl('plugin_author',$cms);
		return( &_script_tag_pl('plugin_list',$cms) );
	} else {
		my $set_data = sb::Plugin->get_data;
		my $show_version = ($set_data->setting) ? $set_data->setting : &sb::Admin::TabulatePlugins::SHOW_VERSION;
		my $srvadr = $var{'conf'}->value('conf_srv_cgi');
		my %plugins = sb::Plugin->get_list;
		my $result = '';
		my %plugins_by_author = ();
		my @plugins_s = ();
		foreach my $file (keys(%plugins)) {
			push(@plugins_s, $plugins{$file}->{'name'} . '<>' . $file);
		}
		@plugins_s = sort @plugins_s;
		my $pluglen = @plugins_s;
		for(my $i = 0; $i < $pluglen;$i++) {
			my $file = (split(/<>/,$plugins_s[$i]))[1];
			next if(&sb::Plugin::_ignore_plugin($file));
			my $publish = $plugins{$file}->{'publish'};
			next if(($publish ne '') && ($publish eq 'no'));
			my $name = $plugins{$file}->{'name'};
			my $text = $plugins{$file}->{'text'};
			my $detail = $plugins{$file}->{'detail'};
			my $version = $plugins{$file}->{'version'};
			my $author = $plugins{$file}->{'author'};
			my $link_string = ($name ne '') ? $name : $file;
			my $title = '';
			if($version ne '') {
				if($show_version eq '1') {
					$link_string .= ' ' . $version;
				} elsif ($show_version eq '2') {
					$title = $version;
				}
			}
			if($text ne '') {
				if($title ne '') {
					$title .= '/';
				}
				$title .= $text;
			}
			if($title ne '') {
				$title = ' title="' . $title . '"';
			}
			my $result_tmp = '<li>';
			if(($detail ne '') && ($detail ne $srvadr)) {
				$result_tmp .= sprintf(LINK_FORMAT,$detail,$title,$link_string);
			} else {
				$result_tmp .= sprintf(SPAN_FORMAT,$title,$link_string);
			}
			$result_tmp .= '</li>' . "\n";
			$plugins_by_author{$author} = '' if(!$plugins_by_author{$author});
			$plugins_by_author{$author} .= $result_tmp;
			$result .= $result_tmp;
		}
		my $result_author = '';
		my @authors = sort keys(%plugins_by_author);
		my $authlen = @authors;
		for(my $i = 0; $i < $authlen;$i++) {
			$result_author .= '<li>' . $authors[$i] . "<br />\n";
			$result_author .= '<ul>' . $plugins_by_author{$authors[$i]} . "</ul>\n</li>\n";
		}
		if($result ne '') {
			$cms->num(0);
			$result = "<ul>\n" . $result . "</ul>\n";
			$result_author = "<ul>\n" . $result_author . "</ul>\n";
			$cms->tag('plugin_list'=>$result);
			$cms->tag('plugin_author'=>$result_author);
			my $dir = sb::Config->get->value('conf_dir_base') . sb::Config->get->value('conf_dir_log');
			my $file = $dir . $mListScripts{'plugin_list'};
			&sb::Build::_generate_javascript($file,$result);
			$file = $dir . $mListScripts{'plugin_author'};
			&sb::Build::_generate_javascript($file,$result_author);
			return(1);
		} else {
			return(0);
		}
	}
}
# ==================================================
# // private functions - other utilities
# ==================================================
sub _script_tag_pl {
	my ($key,$cms) = @_;
	my $conf = sb::Config->get;
	my $check = $conf->value('conf_dir_base') . $conf->value('conf_dir_log') . $mListScripts{$key};
	if (-e $check and -s $check) {
		my $script = sprintf(&sb::Build::SCRIPT_TAG,
			sb::Language->get->charset,
			$conf->value('conf_srv_base') . $conf->value('conf_dir_log') . $mListScripts{$key}
		);
		$cms->num(0);
		$cms->tag($key=>$script);
		return 1;
	} else {
		return 0;
	}
}

package sb::Admin::TabulatePlugins;
use sb::Text ();
use vars qw( @ISA );
use sb::Interface ();
use sb::TemplateManager ();
@ISA = qw( sb::App::Admin );
# ==================================================
# // declaration for constant value
# ==================================================
sub TEMPLATE  (){ 'tabulateplugins.html' };
sub SHOW_VERSION  (){ '0' };
# ==================================================
# // public functions - callback
# ==================================================
sub callback {
	my $self = shift;
	return ( $self->{'regi'} ) 
		? $self->_save_setting(@_)
		: $self->_show_setting(@_);
}
# ==================================================
# // private functions - main routine
# ==================================================
sub _save_setting {
	my $self = shift;
	my $cgi  = sb::Interface->get;
	# ǡμ
	my $set_data = sb::Plugin->get_data;
	# μ
	$set_data->setting($cgi->value('show_version'));
	# ǡ¸
	sb::Plugin->set_data('data' => $set_data);
	# ¸λåɽ
	my $lang = sb::Language->get;
	my $msg = $lang->string('parts_confcomp');
	$msg .= $lang->string('parts_rec_make');
	$msg .= sprintf($lang->string('parts_link_bld'),&sb::App::Admin::get_script_path);
	return $self->_show_setting('message'=>$msg);
}
sub _show_setting {
	my $self = shift;
	my %param = ('message' => '', @_);
	my $cms  = sb::TemplateManager->new(sb::Plugin->load_template('file' => TEMPLATE));
	my $set_data = sb::Plugin->get_data;
	my $show_version = ($set_data->setting) ? $set_data->setting : SHOW_VERSION;

	# ȼͤ
	$cms->num(0);
	$cms->tag('sb_tabulateplugins_show_version_0' => ($show_version eq '0') ? ' selected' : '' );
	$cms->tag('sb_tabulateplugins_show_version_1' => ($show_version eq '1') ? ' selected' : '' );
	$cms->tag('sb_tabulateplugins_show_version_2' => ($show_version eq '2') ? ' selected' : '' );

	# åɽ
	if ($param{'message'} ne '') {
		$cms->num(0);
		$cms->tag('sb_process_message' => $param{'message'});
		$cms->block('sb_process_message' => 1);
	}

	# ̤ɽ
	return sb::Interface->get->head('type'=>'text/html') . $self->set_main($cms->output);
}
1;
__END__
